plugins['hotdesk'] = (function() {

    return { 

        loadLang: function(values) {
            debug('load lang hotdesk');
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~hotdesk" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            debug('set lang hotdesk');
            $('#tagcall').html(lang.hotdesktag);
        },

        init: function() {
            // initialization function
            debug("init de hostdesk");
            var tag_enable = pluginconfig['hotdesk']['call_tags'][''];
            if(tag_enable=='') {
            } else {
                $('#box_asternicTagbox').show();
            }
        },

        callback_directionhotdesk: function(nro,texto,slot) {
            debug("set direction hotdesk "+texto);
            slot = 1;
            var phoni = $('#phone' + slot + '_' + nro)

            if (phoni == null) {
            } else {
                if (texto == "outbound") {
                    phoni.addClass('saliente');
                } else {
                    phoni.addClass('entrante');
                }
            }
        },
        callback_link: function(nro,texto,slot) {
            if(typeof pluginconfig['hotdesk']['lastdial'] == 'undefined') {
                pluginconfig['hotdesk']['lastdial']={};
                pluginconfig['hotdesk']['lastdial'][''+nro]=texto;
            }
        },
        callback_settexthotdesk: function(nro,texto,slot) {
            debug("set text hotdesk "+texto);
            slot = 1;
            var clidnum = $("#clid" + slot + "_" + nro);
            var tag_enable = pluginconfig['hotdesk']['call_tags'][''];
            
            if(tag_enable=='') {
            } else {
                if(typeof pluginconfig['hotdesk']['lastdial'] == 'undefined') {
                    pluginconfig['hotdesk']['lastdial']={};
                }
                pluginconfig['hotdesk']['lastdial'][''+nro]=texto;
            }

            if (texto.substring(0, 1) == "&") {
                texto = translate(texto);
            }

            if (clidnum == null) {
            } else {
                clidnum.html(texto);
                clidnum.attr('title', texto);
            }
        },
        callback_POPUPAGENTCOMPLETE: function(nro,texto,slot) {
            debug("hotdesk callback popup uniqueid "+texto);
            unifull=texto;
            last_dial = pluginconfig['hotdesk']['lastdial'][''+nro];
            tag_enable = pluginconfig['hotdesk']['call_tags'][''];
            if(tag_enable=='') {
            } else {
                partes = pluginconfig['hotdesk']['call_tags'][''].split("|");
                $('#asternicTag').html("<div style='width:90%;padding:10px;'><form id='hotdesktagform' action='admin/plugins/hotdesk/tagcall.php' method='post'><input type=hidden name='tagunique' value='"+unifull+"'>"+lang['number']+" "+last_dial+"<br/><span>"+lang['hotdesktag']+"</span>: <select name='hotdesktagcall' id='hotdesktagcall'></select><br/><input type='submit'/></form></div>"); 
                $('#hotdesktagcall').append($('<option>').text('').attr('value', ''));
                $('#hotdesktagform').submit( 
                    function( event ) {

                        $.ajax({
                            url     : $(this).attr('action'),
                            type    : $(this).attr('method'),
                            dataType: 'json',
                            data    : $(this).serialize(),
                            success : function( data ) {
                                debug('Submitted');
                                $('#asternicTag').html('Ok');
                            },
                            error   : function( xhr, err ) {
                                debug('Error');     
                                $('#asternicTag').html('Error');
                                debug(err);
                            }
                        });    

                        event.preventDefault();
                    }
                );
                for (var i=0,  tot=partes.length; i < tot; i++) {
                    $('#hotdesktagcall').append($('<option>').text(partes[i]).attr('value', partes[i]));
                } 
                //$('#tagcall').chosen({ disable_search_threshold: 10 });
            }

        },
        callback_notifyconnect: function(nro,texto,slot) {
            debug("hotdesk notify connect "+texto );
            tag_enable = pluginconfig['hotdesk']['call_tags'][''];
            if(tag_enable=='') {
            } else {

                if (chanvars[nro] === undefined) {
                    chanvars[nro] = {};
                }

                chanvars[nro]['CLIDNUM'] = ringclidnum[nro];
                chanvars[nro]['CLIDNAME'] = ringclidname[nro];
                unifull        = chanvars[nro]['UNIQUEID'];
                number_calling = Base64.decode(chanvars[nro]['CLIDNUM']);
                name_calling   = Base64.decode(chanvars[nro]['CLIDNAME']);

                partes = pluginconfig['hotdesk']['call_tags'][''].split("|");
                $('#asternicTag').html("<div style='width:90%;padding:10px;'><form id='hotdesktagform' action='admin/plugins/hotdesk/tagcall.php' method='post'><input type=hidden name='tagunique' value='"+unifull+"'>"+lang['number']+" "+number_calling+" ("+name_calling+")<br/><span>"+lang['hotdesktag']+"</span>: <select name='hotdesktagcall' id='hotdesktagcall'></select><br/><input type='submit'/></form></div>"); 
                $('#hotdesktagcall').append($('<option>').text('').attr('value', ''));
                $('#hotdesktagform').submit( 
                    function( event ) {

                        $.ajax({
                            url     : $(this).attr('action'),
                            type    : $(this).attr('method'),
                            dataType: 'json',
                            data    : $(this).serialize(),
                            success : function( data ) {
                                debug('Submitted');
                                $('#asternicTag').html('Ok');
                            },
                            error   : function( xhr, err ) {
                                debug('Error');     
                                $('#asternicTag').html('Error');
                                debug(err);
                            }
                        });    

                        event.preventDefault();
                    }
                );
                for (var i=0,  tot=partes.length; i < tot; i++) {
                    $('#hotdesktagcall').append($('<option>').text(partes[i]).attr('value', partes[i]));
                } 
 
            } 
        },
        callback_notionline: function(nro,texto,slot) {

            debug("hotdesk callback notionline my position="+myposition+" and texto = "+texto);

            if(myposition==texto) {
               if(typeof(hotdeskposition)=='string') {
                    // prevent positions popup to show on fop2 server reload
                } else {
                    send("<msg data=\""+myposition+"|hotdeskpositions|0\" />");
                }
            }
        },
        callback_hotdeskpositions: function(nro,texto,slot) {

            var data = jQuery.parseJSON(Base64.decode(texto));

            debug('hotdeskpositions');

            if(nro==myposition) {

            if(typeof data['start'] == 'undefined') {
            } else {

                debug('hotdesk position start')

                $('<div class="contact-area" style="margin:auto; margin-top:1em; text-align:center;"><br/><div style="width:150px; float:left;"><label for="position" id="labelposition"></label>:</div><div style="float:left;"><select name="position" id="hotdeskposition" style="width:200px;"></select></div><div style="clear:both;"><br/><br/><div style="width:150px; float:left"><label for="profile" id="labelprofile"></label>:</div><div style="float:left;"><select name="profile" id="hotdeskprofile" style="width:200px;"></select></div><br/><br/><div style="clear:both; text-align:center;"> <button id="hotdeskacceptbutton" class="alertify-button alertify-button-ok simplemodal-close butAccept"></button></div></div>').modal({
                    overlayCss: 'osx-overlay',
                    containerCss: 'osx-container',
                    overlayId: 'osx-overlay',
                    containerId: 'osx-container',
                    maxHeight: 300,
                    minWidth: 300,
                    height: 300,
                    width: 300,
                    onOpen: function(dialog) {
                        dialog.overlay.fadeIn('slow', function() {
                            dialog.data.hide();
                            $('#asternicTag').html('');
                            $('.simplemodal-close').hide(); 
                            $('.butAccept').show(); 
                            $('#hotdeskposition').chosen({ disable_search_threshold: 10 });
                            $('#hotdeskprofile').chosen({ disable_search_threshold: 10 });

                            $('#hotdeskacceptbutton').prop('disabled',true);

                            // If there is no profile selected, disable button
                            $( '#hotdeskposition' ).change(function() {
                                $('#hotdeskacceptbutton').prop('disabled',false);
                                if($("#hotdeskprofile").prop("selectedIndex")==0) {
                                    $('#hotdeskacceptbutton').prop('disabled',true);
                                }

                            });

                            // If there is no position selected, disable button
                            $( '#hotdeskprofile' ).change(function() {
                                $('#hotdeskacceptbutton').prop('disabled',false);
                                if($("#hotdeskposition").prop("selectedIndex")==0) {
                                    $('#hotdeskacceptbutton').prop('disabled',true);
                                }
                            });

                            debug('About to set language string '+lang);
                            $('#labelposition').html(lang.hotdeskposition);
                            $('#labelprofile').html(lang.hotdeskprofile);
                            $('.butAccept').html(lang.accept);
                            debug('Done setting language');

                            dialog.container.fadeIn('slow', function() {
                                dialog.data.slideDown('slow');
                            });
                        });
                    },
                    onClose: function(dialog) {
                        dialog.data.fadeOut('slow', function() {
                            dialog.container.hide('slow', function() {
                                dialog.overlay.slideUp('slow', function() {
                                    var chan = $('#hotdeskposition').val();
                                    var name = botonitos[myposition]['LABEL'];
                                    hotdeskposition = Base64.encode(chan);


                                    hotdeskpositionextension = chan.substr(4);
                                    hotdeskpositionvirtual   = botonitos[myposition]['EXTENSION'];

                                    if($("#hotdeskprofile").prop("selectedIndex")==0 && $("#hotdeskposition").prop("selectedIndex")==0) {
                                        debug('no eligio nada, no hago nada');
                                    } else {

                                    if(typeof pluginParam == 'undefined') { pluginParam = {}; }
                                    pluginParam['hotdeskposition'] = $('#hotdeskposition option:selected').text();
                                    pluginParam['hotdeskprofile']  = $('#hotdeskprofile option:selected').text();

                                    hotdeskprofile  = $('#hotdeskprofile').val();
                                    var profilename = $("#hotdeskprofile option:selected").html()
                                    send("<msg data=\"GENERAL|hotdeskprofile|" + profilename + "~"+hotdeskposition+"|\" />");
                                    partes = hotdeskprofile.split("|");
                                    var qar = [];
                                    for (var i=0,  tot=partes.length; i < tot; i++) {
                                        pertes = partes[i].split(",");
                                        var cola = pertes[0];
                                        var penalty = pertes[1];
                                        if(typeof penalty == 'undefined') { penalty = 0; }
                                        var qstr = chan+"|Penalty="+penalty+"|MemberName="+name+"|Queue="+cola+"|Profile="+profilename;
                                        debug(qstr);
                                        qar.push(qstr); 
                                    }
                                    if(typeof pluginconfig['hotdesk']['queueprefix'] !== 'undefined') {
                                    if(typeof pluginconfig['hotdesk']['queueprefix'][profilename] !== 'undefined') {
                                        var queueprefix = pluginconfig['hotdesk']['queueprefix'][profilename];
                                        var qstr = chan+"|Penalty=0|MemberName="+name+"|Queue="+queueprefix+hotdeskpositionvirtual+"|Profile="+profilename;
                                        debug(qstr);
                                        qar.push(qstr); 
                                    }
                                    }

                                    finalstring = qar.join("&");
                                    debug(finalstring);
                                    sendqchan = Base64.encode(finalstring);
                                    send("<msg data=\"GENERAL|qchan|" + sendqchan + "|\" />");
                                    send("<msg data=\"GENERAL|mychan|" + hotdeskposition + "|\" />");
                                    send("<msg data=\"GENERAL|hotdeskmap|" + hotdeskpositionvirtual + '~' + hotdeskpositionextension +  '~' + hotdeskposition + "|\" />");
                                    }
                                    $.modal.close();
                                });
                            });
                        });
                    }
                });

                $('#hotdeskposition').empty();
                $('#hotdeskposition').append($('<option>').text('').attr('value', ''));
            }

            for (var pepe in data['p']) {
                $('#hotdeskposition').append($('<option>').text(data['p'][pepe]['e']).attr('value', data['p'][pepe]['d']));
            }

            $('#hotdeskprofile').empty();
            $('#hotdeskprofile').append($('<option>').text('').attr('value', ''));

            var sortedkeys = [];
            for (var key in pluginconfig['hotdesk']['profile']) {
                debug(key);
                sortedkeys.push(key);
            }
            sortedkeys.sort();

            for (var i=0,  tot=sortedkeys.length; i < tot; i++) {
                var key = sortedkeys[i];
                if(pluginconfig['hotdesk']['profile'].hasOwnProperty(key)) {
                  if(key=='') {
                      // discard empty option
                  } else {
                      $('#hotdeskprofile').append($('<option>').text(key).attr('value', pluginconfig['hotdesk']['profile'][key]));
                  }
               }
            }

            if(typeof data['end'] == 'undefined') {
            } else {
                debug('hotdesk position end')
                autoclose=0;
                var getHotdeskPosition  = gup("hotdeskposition");
                $('#hotdeskposition > option').each(function() { if(getHotdeskPosition==this.text) {  $(this).attr('selected','selected'); if(getHotdeskPosition=="") { } else { autoclose++; } }  });

                var getHotdeskProfile  = gup("hotdeskprofile");
                $('#hotdeskprofile > option').each(function() { if(getHotdeskProfile==this.text) {  $(this).attr('selected','selected');  if(getHotdeskProfile=="") { } else { autoclose++; } } });

                $("#hotdeskposition").trigger("chosen:updated");
                debug(autoclose);
                debug(autoclose);
                if(autoclose==2) { 
                   $.modal.close();
                }
            }

            $("#hotdeskprofile").trigger("chosen:updated");

            }
        }
    }
}());
