#!/usr/bin/php
<?php

if (php_sapi_name() !='cli') exit;

$conf = parse_conf("/etc/amportal.conf");

$HOST = trim($conf['DBHOST']);
$USER = trim($conf['DBUSER']);
$PASS = trim($conf['DBPASS']);
$DATA = trim($conf['DBNAME']);

$db = new mysqli($HOST, $USER, $PASS, $DATA);
if ($db->connect_errno) {
    echo "Fallo al contenctar a MySQL: (" . $db->connect_errno . ") " . $db->connect_error;
    die();
}

// Just in case, alter table to expand field
$query = "ALTER TABLE queues_config CHANGE extension extension varchar(45)";
$result = $db->query($query);

// Drop all queues with textual names from Mysql
$query = "SELECT extension FROM queues_config WHERE extension not REGEXP '[0-9]'";
$result = $db->query($query);
if($result) {
    while($obj = $result->fetch_object()) {
        $query = "DELETE FROM queues_config WHERE extension='".$obj->extension."'";
        $db->query($query); 
        echo "$query\n";
        $query = "DELETE FROM queues_details WHERE id='".$obj->extension."'";
        echo "$query\n";
        $db->query($query); 
    }
    $result->close();
}

$ini_array = parse_ini_file("hotdesk.ini",true);

foreach($ini_array as $key => $data) {
    if(is_array($data)) {

       $partes = preg_split("/,/",$data['profile']);

        echo trim($partes[0])."=".$key."\n";

        if(trim($partes[0]=="$key")) {

            $query = "INSERT INTO queues_config (extension,descr) VALUES ( ?, ? )";
            $stmt = $db->prepare($query);
            $stmt->bind_param('ss',$key,$key);
            $stmt->execute();

            $query = "INSERT INTO queues_details VALUES (?,'joinempty','no',0)";
            $stmt = $db->prepare($query);
            $stmt->bind_param('s',$key);
            $stmt->execute();
        }
    }
}

system("/var/lib/asterisk/bin/retrieve_conf");

function parse_conf($filename) {

    global $config_engine;

    $file = file($filename);

    foreach ($file as $line) {
        if (preg_match("/^\s*([\w]+)\s*=\s*\"?([^\"]*)?\"?/",$line,$matches)) {
            $matches[1] = preg_replace("/^AMP/","",$matches[1]);
            $conf[ $matches[1] ] = $matches[2];
        }
    }

    return $conf;
}


